(in-package #:lascivious)

(use-package "ALIEN")
(use-package "C-CALL")

(declaim (optimize (speed 3) (safety 0)))

(load-foreign "volume_io.o")
(def-alien-variable "rawdata" (* unsigned-char))
(def-alien-variable "magic_number" int)
(def-alien-variable "header_length" int)
(def-alien-variable "vol_width" int)
(def-alien-variable "vol_height" int)
(def-alien-variable "vol_images" int)
(def-alien-variable "pixel_depth" int)
(def-alien-variable "pixel_format" int)
(def-alien-variable "pixel_type" int)
(def-alien-variable "index_bits" int)
(def-alien-variable "scale_x" int)
(def-alien-variable "scale_y" int)
(def-alien-variable "scale_z" int)
(def-alien-variable "rot_x" int)
(def-alien-variable "rot_y" int)
(def-alien-variable "rot_z" int)

(declaim (inline read-volume))
(def-alien-routine "read_volume" void
  (filename c-string))

;; An interface to the alien READ-VOLUME function.
;; Sets a number of global variables.
(defun read-vol-file& (vol path)
  "Reads the volume file specified in PATH.  Modifies the VOL structure as
  well as some global data."
  (declare (volume vol))
  
  (read-volume path)
  
  (setf (volume-vol-width  vol) vol-width)
  (setf (volume-vol-height vol) vol-height)
  (setf (volume-vol-images vol) vol-images)  
  
  (setf (volume-vol-max-width  vol) (- vol-width 1.0d0))
  (setf (volume-vol-max-height vol) (- vol-height 1.0d0))
  (setf (volume-vol-max-depth  vol) (- vol-images 1.0d0))
  
  (format t "Volume width = ~A pixels~%" vol-width)
  (format t "Volume height = ~A pixels~%" vol-height)
  (format t "Volume images = ~A pixels~%" vol-images))
