(defpackage #:geometry
  (:use #:common-lisp #:vector)
  (:export #:polygon #:polygon-num-verts #:polygon-vertices #:polygon-color
	   #:quad #:quad-a #:quad-b #:quad-c #:quad-d
	   #:intersect-line-cube))
 
   

(in-package #:geometry)

(defstruct polygon
  (num-verts 0 :type fixnum)     ; number of vertices in the polygon
  vertices                       ; a list of integer indices to the vertex table
  color)                         ; 

(defstruct quad
  (a (make-vec3) :type vec3)
  (b (make-vec3) :type vec3)
  (c (make-vec3) :type vec3)
  (d (make-vec3) :type vec3)
  (n (make-vec3) :type vec3))


(defun intersect-seg-quad (seg-start seg-end quad)
  (declare (vec3 seg-start seg-end) (quad quad))
  ; P(t) = P0 + (p-delta * t)
  (let ((p-delta (vec- seg-end segstart))
	(t 0.0d0)
	(a (vec- (quad-b quad) (quad-a quad)))
	(n (quad-n quad)))
    (declare (double-float t) (vec3 p-delta a n))
    nil))

(defun intersect-seg-cube (seg-start seg-end top bottom front back left right)
  (declare (quad top bottom front back left right) (vec3 seg-start seg-end))
  nil)

(defun intersect-plane-cube (plane top bottom front back left right)
  nil)

(defun intersect-plane-plane (plane1 plane2)
  nil)
