(load "../vector.x86f")
(load "../geometry.x86f")
(load "lascivious.lsp")
(load "macros.x86f")
(load "datastructs.x86f")
(load "alienstuff.x86f")
(load "volrender.x86f")

;(use-package "VECTOR")
;(use-package "LASCIVIOUS")
(in-package #:lascivious)

(defun temp-set-materials (materials)
  (let ((mat0 (aref materials 0))
	(mat1 (aref materials 1))
	(mat2 (aref materials 2)))
    (set-material! mat0 0.18 0.18 0.18 0.35 0.35 0.35 0.0 0.0 0.0 10.0)
    (set-material! mat1 0.25 0.0  0.0  0.25 0.0 0.0 0.0 0.0 0.0 10.0)
    (set-material! mat2 0.25 0.25 0.25 0.5 0.5 0.5 0.0 0.0 0.0 10.0)))
    
(defun temp-set-lights (lights)
  (setf (aref lights 0) (make-lightsource :dir (normalize (make-vec3 :x -1.0d0
								     :y 1.0d0
								     :z -1.0d0))))
  (setf (aref lights 1) (make-lightsource :dir (normalize (make-vec3 :x -1.0d0
								     :y -1.0d0
								     :z 1.0d0)))))


;(read-vol-file& "/home/jonathan/coding/volume_rendering/data/engine.vol")
;(read-vol-file& "/home/jonathan/coding/volume_rendering/data/cthead.vol")
;(read-vol-file& "/home/jonathan/coding/volume_rendering/data/mrbrain.vol")

(let ((m1 (m** (translate -127.5d0 -127.5d0 -54.5d0)
	       (rotate-y 1)
	       (translate 127.5d0 127.5d0 54.5d0)
	       (proj-norm 0.0d0 (- vol-width 1.0d0)
			  0.0d0 (- vol-height 1.0d0)
			  0.0d0 (- vol-images 1.0d0))))
      (m2 (proj-norm 0.0d0 (- vol-width 1.0d0)
		     0.0d0 (- vol-height 1.0d0)
		     0.0d0 (- vol-images 1.0d0)))
      (m3 (m** (translate -127.5d0 -127.5d0 -54.5d0)
	       (rotate-y -45)
	       (translate 127.5d0 127.5d0 54.5d0)))
      (iden (mat4x4-identity))
      context vol)

  (defun init-lascivious ()
    
    (setf context (make-render-context :num-lights 1))
    ;(setf vol (make-volume :trans m3))
    (setf vol (make-volume :trans iden :shade-func (get-shade-func 
						  (render-context-num-lights context))))
    
    (read-vol-file& vol "/home/jonathan/coding/volume_rendering/data/engine.vol")
#|
    (setf (volume-trans vol) (m** (translate (/ (- vol-width 1.0d0) -2.0d0)
					     (/ (- vol-height 1.0d0) -2.0d0)
					     (/ (- vol-images 1.0d0) -2.0d0))
				  (rotate-y -210)
				  (translate (/ (- vol-width 1.0d0) 2.0d0)
					     (/ (- vol-height 1.0d0) 2.0d0)
					     (/ (- vol-images 1.0d0) 2.0d0))))
|#
    (temp-set-materials (volume-materials vol))
    
    (set-opacity-lut (volume-scalar-opacity-lut vol) 0   to 99  gets 0.0)
    (set-opacity-lut (volume-scalar-opacity-lut vol) 100 to 170 gets 0.05)
    (set-opacity-lut (volume-scalar-opacity-lut vol) 171 to 184 gets 0.0)
    (set-opacity-lut (volume-scalar-opacity-lut vol) 185 to 235 gets 0.9)  
    (set-opacity-lut (volume-scalar-opacity-lut vol) 236 to 255 gets 0.0)
    
    (set-opacity-lut (volume-grad-opacity-lut vol) 0 to 4  gets 0.0)
    (set-opacity-lut (volume-grad-opacity-lut vol) 5 to 20 gets 0.0 to 1.0)
    (set-opacity-lut (volume-grad-opacity-lut vol) 21 to 221 gets 1.0)
    
    (set-material-lut (volume-mat-lut vol) 0 to 171 gets 0)
    (set-material-lut (volume-mat-lut vol) 172 to 255 gets 1)
    
    (temp-set-lights (render-context-lights context))
    
    ;(profile:profile vec4-x)
    ;(profile:profile accumulate)
    ;(profile:profile shade)
    ;(profile:profile calc-gradient)
    ;(profile:profile classify)
    ;(profile:profile trilinear-interpolate)
  )

  (defun rotate-vol (degrees)
    (setf (volume-trans vol) (m** (translate (/ (- vol-width 1.0d0) -2.0d0)
					     (/ (- vol-height 1.0d0) -2.0d0)
					     (/ (- vol-images 1.0d0) -2.0d0))
				  (rotate-y degrees)
				  (translate (/ (- vol-width 1.0d0) 2.0d0)
					     (/ (- vol-height 1.0d0) 2.0d0)
					     (/ (- vol-images 1.0d0) 2.0d0)))))
  
  (defun run-lascivious ()
    (time (volrender vol context)))

  

  )








