#define VR_MAGIC_NUMBER_OLD           192837465
#define VR_MAGIC_NUMBER               192837466

#define MANUFACTURER_STRING_LENGTH    20
#define ORIG_FILENAME_STRING_LENGTH   128

#define UNSIGNED_BYTE                 1001
#define UNSIGNED_SHORT                1002

#define INTENSITY8                    2001
#define INTENSITY16                   2002
#define INDEX4_INTENSITY12            2003
#define INDEX8_INTENSITY8             2004

/*+---------------------------+
  |   Structure Definitions   |
  +---------------------------+*/

typedef struct {
    int x, y, z;  
} IntTuple;

typedef struct {
  int magic_num;
  int header_length;
  int x, y, z;
  int pixel_depth;
  int pixel_format;
  int pixel_type;
  int index_bits;
  float scale_x, scale_y, scale_z;
  float rotx, roty, rotz;
  char manufacturer[MANUFACTURER_STRING_LENGTH];
  char original_filename[ORIG_FILENAME_STRING_LENGTH];
} VolHeader;

/*+-------------+
  |   Globals   |
  +-------------+*/

/*----- Info from data file header... -----*/
int   magic_number;
int   header_length;

int         vol_width, vol_height, vol_images;   /* size of the volume */
int         pixel_depth;
int         pixel_format;        /* format */
int         pixel_type;          /* type */
int         index_bits;          /* number of "object" index bits */
                                 /* in each pixel                 */

float     scale_x;             /* base scale factors */
float     scale_y;
float     scale_z;

float     rot_x;               /* base rotation */
float     rot_y;
float     rot_z;

char        manufacturer[MANUFACTURER_STRING_LENGTH];
char        original_filename[ORIG_FILENAME_STRING_LENGTH];


unsigned char *rawdata;
unsigned short *rawsdata;

/*+-------------------------+
  |   Function Prototypes   |
  +-------------------------+*/

int read_volume(char *filename);


